=== PKGBUILD ===
# Maintainer: SANO Masatoshi <snmsts@gmail.com>
_realname=roswell
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=24.10.115
pkgrel=1
pkgdesc="Lisp installer and launcher (mingw-w64)"
url="https://github.com/roswell/roswell"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64')
license=("spdx:MIT")
depends=()
makedepends=("${MINGW_PACKAGE_PREFIX}-autotools"
             "${MINGW_PACKAGE_PREFIX}-cc")
optdepends=()
source=("https://github.com/roswell/roswell/archive/v$pkgver.tar.gz")
sha256sums=('9c23cb263d4645caaae21cda8f1f5793b0f08ee5c5338aab5974cb4f473d1c4b')

build() {
  cd "${srcdir}"/${_realname}-${pkgver}
  ./bootstrap
  ./configure \
    --prefix=${MINGW_PREFIX} \
    --build=${MINGW_CHOST} \
    --host=${MINGW_CHOST} \
    --target=${MINGW_CHOST} \

  make
}

package() {
  cd "${_realname}-$pkgver"

  make install DESTDIR="${pkgdir}"

  install -Dm644 COPYING "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"

}
